Shell scripting: die on any error


Question

Suppose a shell script (/bin/sh or /bin/bash) contained several commands. How can I cleanly make the script terminate if any of the commands has a failing exit status? Obviously, one can use if blocks and/or callbacks, but is there a cleaner, more concise way? Using && is not really an option either, because the commands can be long, or the script could have non-trivial things like loops and conditionals.

1
34
12/15/2008 4:01:28 PM

Accepted Answer

With standard sh and bash, you can

set -e

It will

$ help set
...
        -e  Exit immediately if a command exits with a non-zero status.

It also works (from what I could gather) with zsh. It also should work for any Bourne shell descendant.

With csh/tcsh, you have to launch your script with #!/bin/csh -e

60
12/16/2008 3:59:14 AM

May be you could use:

$ <any_command> || exit 1

Licensed under: CC-BY-SA with attribution
Not affiliated with: Stack Overflow
Icon